<template>
  <div class="cart-products container">
    <div class="row mt-5">
      <div class="col-lg-8 col-sm-12 checkout-form">
        <div class="single-line-input">
          <div class="form-group m-dropdown" v-click-outside="hideShippingType">
            <label for="shippingType">Способ Отправки</label>
            
            <input class="main-input" @focus="showShippingType = true;" autocomplete="off" name="shippingType" v-model="orderDetails.userDetails.shippingType">

            <ul v-if="showShippingType" class="m-dropdown-menu" >
              <li v-for="c in shippingTypes" @click.stop="setShippingType(c)">{{c}}</li>
            </ul>
          </div>

          <div class="form-group" v-if="orderDetails.userDetails.shippingType === 'Новая Почта'">
            <label for="office">Номер Отделения</label>
            <input type="text" class="main-input" v-model="orderDetails.userDetails.office" name="office" autocomplete="off">
          </div>
        </div>

        <div class="form-group">
          <label for="fullName">Ф.И.О. Получателя</label>
          <input type="text" class="main-input" :class="{'invalid': checkRequired(orderDetails.userDetails.fullName)}" v-model="orderDetails.userDetails.fullName" name="fullName" autocomplete="off">
        </div>

        <div class="single-line-input">
          
          <div class="form-group">
            <label for="city">Город</label>
            <input type="text" class="main-input" :class="{'invalid': checkRequired(orderDetails.userDetails.city)}" v-model="orderDetails.userDetails.city" name="city" autocomplete="off">
          </div>

          <div class="form-group" v-if="orderDetails.userDetails.shippingType === 'УкрПочта'">
            <label for="zip">Индекс</label>
            <input type="text" class="main-input" v-model="orderDetails.userDetails.zip" name="zip" autocomplete="off">
          </div>
          <div class="form-group">
            <label for="phone">Телефон</label>
            <div class="d-flex">
              <span class="phone-code">+380 </span>
              <input type="text" class="main-input phone-input" :class="{'invalid': checkRequired(orderDetails.userDetails.phone)}" v-model="orderDetails.userDetails.phone" name="phone" autocomplete="off">
            </div>
          </div>
        </div>

        <div class="form-group">
          <label for="comment">Комментарий</label>
          <input type="text" class="main-input" v-model="orderDetails.userDetails.comment" name="comment" autocomplete="off">
        </div>
        * Бесплатная доставка от 1500 грн
      </div>
      <div class="col-lg-4 col-sm-12">
        <ul class="list-group mb-3">
          <button class="action-button gray-button continue-btn" @click="goTo('products')">Продолжить Покупки</button>
          <button class="action-button black-button" @click="confirm">Подтвердить</button>
        </ul>
      </div>
    </div>

    <modal :header="'Подздравляем!'" :isShow="successModal" v-if="successModal" @close="successModal = false">
      <div slot="body">
        <p>Ваш заказ был принят в обрабоку. С Вами свяжутся в корокий срок!</p>
        <p>Нажмите <router-link :to="`/profile?page=2`" >здесь</router-link> чтобы посмотреть заказ.</p>
        
      </div>

      <div slot="footer">
        <button class="action-button gray-button ok-button" @click="successModal = false;">OK</button>
      </div>
    </modal>
  </div>
</template>

<script>
import { mapMutations } from "vuex";
import Modal from "../../shared/Modal";
export default {
  name: "Checkout",
  data() {
    return {
      showRequired: false, successModal: false, showShippingType: false,
      orderDetails: {
        userDetails: {
          city: "",
          phone: "",
          zip: "",
          fullName: "",
          comment: "",
          office: "",
          shippingType: "Новая Почта"
        }
      },
      shippingTypes: ['Новая Почта', 'УкрПочта']
    };
  },
  props: {
    totalPrice: Number,
    promoCode: Object
  },
  components: {
    Modal
  },
  methods: {
    ...mapMutations(["SET_CART_PRODUCTS"]),
    confirm() {
      this.orderDetails.cartProducts = this.$store.getters.cartProducts;
      this.orderDetails.promoCode = this.promoCode;
      this.orderDetails.totalPrice = this.totalPrice;
      if (!this.orderDetails.userDetails.fullName || !this.orderDetails.userDetails.phone  || !this.orderDetails.userDetails.city) {
        return this.showRequired = true;
      } else {
        this.$http.post(`${process.env.VUE_APP_BASE_URL}/orders`, this.orderDetails).then(resp => {
          this.SET_CART_PRODUCTS([]);
          localStorage.setItem("iki-cart", JSON.stringify([]));
          this.successModal = true;
        }).catch(err => {
          console.log(err);
        })
      }
    },
    goTo(page) {
      this.$router.push(page);
    },
    checkRequired(i) {
      return this.showRequired && !i;
    },
    setShippingType(type) {
      this.orderDetails.userDetails.shippingType = type;
      this.showShippingType = false;
    },
    hideShippingType() {
      this.showShippingType = false;
    }
  }
};
</script>

<style lang="scss">
.cart-products {
  padding-bottom: 80px;
  .continue-btn {
    margin-top: 0;
  }
  label {
    text-transform: uppercase;
    letter-spacing: 0.7px;
    color: gray;
  }
  div {
    text-align: start;
  }
  #productCU {
    div {
      text-align: start;
    }
    button {
      text-align: center;
    }
  }
  .single-line-input > div {
    width: 50%;
  }
  .phone-input {
    margin-top: 4px;
  }

  .checkout-form {
    font-size: 16px;
    padding: 15px;
  }
}
</style>
